]> git.ipfire.org Git - people/teissler/ipfire-2.x.git/blob - make.sh
Add auto_fs & auto_fs4 kernel modules
[people/teissler/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.3-test"
28 GIT_BRANCH=master:master # Version number
29 SLOGAN="www.ipfire.org" # Software slogan
30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
31 NICE=10 # Nice level
32 MAX_RETRIES=1 # prefetch/check loop
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
35 GIT_TAG=$(git tag | tail -1)
36
37 IPFVER="full" # Which versions should be compiled? (full|devel)
38
39 # Debian specific settings
40 if [ ! -e /etc/debian_version ]; then
41 FULLPATH=`which $0`
42 else
43 if [ -x /usr/bin/realpath ]; then
44 FULLPATH=`/usr/bin/realpath $0`
45 else
46 echo "ERROR: Need to do apt-get install realpath"
47 exit 1
48 fi
49 fi
50
51 PWD=`pwd`
52 BASENAME=`basename $0`
53 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
54 LOGFILE=$BASEDIR/log/_build.preparation.log
55 export BASEDIR LOGFILE
56 DIR_CHK=$BASEDIR/cache/check
57 mkdir $BASEDIR/log/ 2>/dev/null
58
59 # Include funtions
60 . tools/make-functions
61
62 if [ -f .config ]; then
63 . .config
64 else
65 echo -e "${BOLD}No configuration found!${NORMAL}"
66 echo -ne "Do you want to create one (y/N)?"
67 read CREATE_CONFIG
68 echo ""
69 if [ "$CREATE_CONFIG" == "y" ]; then
70 make_config
71 fi
72 fi
73
74 if [ -z $EDITOR ]; then
75 for i in nano emacs vi; do
76 EDITOR=$(which $i 2>/dev/null)
77 if ! [ -z $EDITOR ]; then
78 export EDITOR=$EDITOR
79 break
80 fi
81 done
82 [ -z $EDITOR ] && exiterror "You should have installed an editor."
83 fi
84
85 prepareenv() {
86 ############################################################################
87 # #
88 # Are we running the right shell? #
89 # #
90 ############################################################################
91 if [ ! "$BASH" ]; then
92 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
93 fi
94
95 if [ -z "${BASH_VERSION}" ]; then
96 exiterror "Not running BASH shell."
97 fi
98
99
100 ############################################################################
101 # #
102 # Trap on emergency exit #
103 # #
104 ############################################################################
105 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
106
107
108 ############################################################################
109 # #
110 # Resetting our nice level #
111 # #
112 ############################################################################
113 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
114 renice $NICE $$ > /dev/null
115 if [ `nice` != "$NICE" ]; then
116 beautify message FAIL
117 exiterror "Failed to set correct nice level"
118 else
119 beautify message DONE
120 fi
121
122
123 ############################################################################
124 # #
125 # Checking if running as root user #
126 # #
127 ############################################################################
128 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
129 if [ `id -u` != 0 ]; then
130 beautify message FAIL
131 exiterror "Not building as root"
132 else
133 beautify message DONE
134 fi
135
136
137 ############################################################################
138 # #
139 # Checking for necessary temporary space #
140 # #
141 ############################################################################
142 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
143 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
144 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
145 if (( 2048000 > $BASE_ASPACE )); then
146 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
147 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
148 beautify message FAIL
149 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
150 fi
151 else
152 beautify message DONE
153 fi
154
155 ############################################################################
156 # #
157 # Building Linux From Scratch system #
158 # #
159 ############################################################################
160 # Set umask
161 umask 022
162
163 # Set LFS Directory
164 LFS=$BASEDIR/build
165
166 # Check /tools symlink
167 if [ -h /tools ]; then
168 rm -f /tools
169 fi
170 if [ ! -a /tools ]; then
171 ln -s $BASEDIR/build/tools /
172 fi
173 if [ ! -h /tools ]; then
174 exiterror "Could not create /tools symbolic link."
175 fi
176
177 # Setup environment
178 set +h
179 LC_ALL=POSIX
180 MAKETUNING="-j6"
181 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
182 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
183
184 # Make some extra directories
185 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
186 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
187 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
188 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
189
190 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
191 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
192
193 # Make all sources and proc available under lfs build
194 mount --bind /dev $BASEDIR/build/dev
195 mount --bind /dev/pts $BASEDIR/build/dev/pts
196 mount --bind /dev/shm $BASEDIR/build/dev/shm
197 mount --bind /proc $BASEDIR/build/proc
198 mount --bind /sys $BASEDIR/build/sys
199 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
200 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
201 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
202 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
203 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
204 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
205 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
206 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
207 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
208
209 # This is a temporary hack!!!
210 if [ ! -f /tools/bin/hostname ]; then
211 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
212 fi
213
214 # Run LFS static binary creation scripts one by one
215 export CCACHE_DIR=$BASEDIR/ccache
216 export CCACHE_HASHDIR=1
217
218 # Remove pre-install list of installed files in case user erase some files before rebuild
219 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
220 }
221
222 buildtoolchain() {
223 LOGFILE="$BASEDIR/log/_build.toolchain.log"
224 export LOGFILE
225 ORG_PATH=$PATH
226 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
227 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
228 lfsmake1 ccache
229 lfsmake1 binutils PASS=1
230 lfsmake1 gcc PASS=1
231 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
232 lfsmake1 linux-libc-header
233 lfsmake1 glibc
234 lfsmake1 cleanup-toolchain PASS=1
235 lfsmake1 tcl
236 lfsmake1 expect
237 lfsmake1 dejagnu
238 lfsmake1 gcc PASS=2
239 lfsmake1 binutils PASS=2
240 lfsmake1 ncurses
241 lfsmake1 bash
242 lfsmake1 bzip2
243 lfsmake1 coreutils
244 lfsmake1 diffutils
245 lfsmake1 findutils
246 lfsmake1 gawk
247 lfsmake1 gettext
248 lfsmake1 grep
249 lfsmake1 gzip
250 lfsmake1 m4
251 lfsmake1 make
252 lfsmake1 patch
253 lfsmake1 perl
254 lfsmake1 sed
255 lfsmake1 tar
256 lfsmake1 texinfo
257 lfsmake1 util-linux
258 lfsmake1 cleanup-toolchain PASS=2
259 export PATH=$ORG_PATH
260 }
261
262 buildbase() {
263 LOGFILE="$BASEDIR/log/_build.base.log"
264 export LOGFILE
265 lfsmake2 stage2
266 lfsmake2 linux-libc-header
267 lfsmake2 man-pages
268 lfsmake2 glibc
269 lfsmake2 cleanup-toolchain PASS=3
270 lfsmake2 binutils
271 lfsmake2 gcc
272 lfsmake2 berkeley
273 lfsmake2 coreutils
274 lfsmake2 iana-etc
275 lfsmake2 m4
276 lfsmake2 bison
277 lfsmake2 ncurses
278 lfsmake2 procps
279 lfsmake2 sed
280 lfsmake2 libtool
281 lfsmake2 perl
282 lfsmake2 readline
283 lfsmake2 zlib
284 lfsmake2 autoconf
285 lfsmake2 automake
286 lfsmake2 bash
287 lfsmake2 bzip2
288 lfsmake2 diffutils
289 lfsmake2 e2fsprogs
290 lfsmake2 ed
291 lfsmake2 file
292 lfsmake2 findutils
293 lfsmake2 flex
294 lfsmake2 gawk
295 lfsmake2 gettext
296 lfsmake2 grep
297 lfsmake2 groff
298 lfsmake2 gzip
299 lfsmake2 inetutils
300 lfsmake2 iproute2
301 lfsmake2 kbd
302 lfsmake2 less
303 lfsmake2 libaal
304 lfsmake2 make
305 lfsmake2 man
306 lfsmake2 mktemp
307 lfsmake2 modutils
308 lfsmake2 mtd
309 lfsmake2 net-tools
310 lfsmake2 patch
311 lfsmake2 psmisc
312 lfsmake2 reiser4progs
313 lfsmake2 shadow
314 lfsmake2 sysklogd
315 lfsmake2 sysvinit
316 lfsmake2 tar
317 lfsmake2 texinfo
318 lfsmake2 udev
319 lfsmake2 util-linux
320 lfsmake2 vim
321 lfsmake2 grub
322 }
323
324 buildipfire() {
325 LOGFILE="$BASEDIR/log/_build.ipfire.log"
326 export LOGFILE
327 ipfiremake configroot
328 ipfiremake backup
329 ipfiremake dhcp
330 ipfiremake dhcpcd
331 ipfiremake libusb
332 ipfiremake libpcap
333 ipfiremake ppp
334 ipfiremake rp-pppoe
335 ipfiremake unzip
336 # ipfiremake linux SMP=1
337 # ipfiremake linux-fusion SMP=1
338 # ipfiremake ipp2p SMP=1
339 # ipfiremake r8169 SMP=1
340 # ipfiremake r8168 SMP=1
341 # ipfiremake atl2 SMP=1
342 # ipfiremake kqemu SMP=1
343 # ipfiremake v4l-dvb SMP=1
344 # ipfiremake madwifi SMP=1
345 # ipfiremake alsa KMOD=1 SMP=1
346 # ipfiremake sane KMOD=1 SMP=1
347 # ipfiremake openswan KMOD=1 SMP=1
348 ipfiremake linux
349 ipfiremake linux-fusion
350 # ipfiremake ipp2p
351 ipfiremake r8169
352 ipfiremake r8168
353 ipfiremake atl2
354 ipfiremake kqemu
355 ipfiremake v4l-dvb
356 ipfiremake madwifi
357 ipfiremake alsa KMOD=1
358 ipfiremake sane KMOD=1
359 ipfiremake openswan KMOD=1
360 ipfiremake pkg-config
361 ipfiremake linux-atm
362 ipfiremake cpio
363 ipfiremake klibc
364 ipfiremake mkinitcpio
365 ipfiremake udev KLIBC=1
366 ipfiremake expat
367 ipfiremake gdbm
368 ipfiremake gmp
369 ipfiremake pam
370 ipfiremake openssl
371 ipfiremake curl
372 ipfiremake python
373 ipfiremake libnet
374 ipfiremake libidn
375 ipfiremake libjpeg
376 ipfiremake libpng
377 ipfiremake libtiff
378 ipfiremake libart
379 ipfiremake freetype
380 ipfiremake gd
381 ipfiremake popt
382 ipfiremake pcre
383 ipfiremake slang
384 ipfiremake newt
385 ipfiremake libcap
386 ipfiremake pciutils
387 ipfiremake usbutils
388 ipfiremake libxml2
389 ipfiremake libxslt
390 ipfiremake BerkeleyDB
391 ipfiremake mysql
392 ipfiremake cyrus-sasl
393 ipfiremake openldap
394 ipfiremake apache2
395 ipfiremake php
396 ipfiremake apache2 PASS=C
397 ipfiremake arping
398 ipfiremake beep
399 ipfiremake bind
400 ipfiremake cdrtools
401 ipfiremake dnsmasq
402 ipfiremake dosfstools
403 ipfiremake squashfstools
404 ipfiremake reiserfsprogs
405 ipfiremake xfsprogs
406 ipfiremake sysfsutils
407 ipfiremake fuse
408 ipfiremake ntfs-3g
409 ipfiremake ethtool
410 ipfiremake ez-ipupdate
411 ipfiremake fcron
412 ipfiremake perl-GD
413 ipfiremake GD-Graph
414 ipfiremake GD-TextUtil
415 ipfiremake gnupg
416 ipfiremake hdparm
417 ipfiremake sdparm
418 ipfiremake mtools
419 ipfiremake initscripts
420 ipfiremake whatmask
421 ipfiremake iptables
422 ipfiremake libupnp
423 # ipfiremake ipp2p IPT=1
424 ipfiremake linux-igd
425 ipfiremake ipaddr
426 ipfiremake iptstate
427 ipfiremake iputils
428 ipfiremake l7-protocols
429 ipfiremake mISDN
430 ipfiremake capi4k-utils
431 ipfiremake hwdata
432 ipfiremake kudzu
433 ipfiremake logrotate
434 ipfiremake logwatch
435 ipfiremake misc-progs
436 ipfiremake nano
437 ipfiremake nasm
438 ipfiremake URI
439 ipfiremake HTML-Tagset
440 ipfiremake HTML-Parser
441 ipfiremake Compress-Zlib
442 ipfiremake Digest
443 ipfiremake Digest-SHA1
444 ipfiremake Digest-HMAC
445 ipfiremake libwww-perl
446 ipfiremake Net-DNS
447 ipfiremake Net-IPv4Addr
448 ipfiremake Net_SSLeay
449 ipfiremake IO-Stringy
450 ipfiremake Unix-Syslog
451 ipfiremake Mail-Tools
452 ipfiremake MIME-Tools
453 ipfiremake Net-Server
454 ipfiremake Convert-TNEF
455 ipfiremake Convert-UUlib
456 ipfiremake Archive-Tar
457 ipfiremake Archive-Zip
458 ipfiremake Text-Tabs+Wrap
459 ipfiremake Locale-Country
460 ipfiremake XML-Parser
461 ipfiremake glib
462 ipfiremake GeoIP
463 ipfiremake fwhits
464 ipfiremake noip_updater
465 ipfiremake ntp
466 ipfiremake openssh
467 ipfiremake rrdtool
468 ipfiremake setserial
469 ipfiremake setup
470 ipfiremake snort
471 ipfiremake oinkmaster
472 ipfiremake squid
473 ipfiremake squid-graph
474 ipfiremake squidguard
475 ipfiremake calamaris
476 ipfiremake tcpdump
477 ipfiremake traceroute
478 ipfiremake vlan
479 ipfiremake wireless
480 ipfiremake libsafe
481 ipfiremake pakfire
482 ipfiremake java
483 ipfiremake spandsp
484 ipfiremake lzo
485 ipfiremake openvpn
486 ipfiremake pammysql
487 ipfiremake cups
488 ipfiremake ghostscript
489 ipfiremake foomatic
490 ipfiremake hplip
491 ipfiremake samba
492 ipfiremake sudo
493 ipfiremake mc
494 ipfiremake wget
495 ipfiremake bridge-utils
496 ipfiremake screen
497 ipfiremake hddtemp
498 ipfiremake smartmontools
499 ipfiremake htop
500 ipfiremake postfix
501 ipfiremake fetchmail
502 ipfiremake cyrus-imapd
503 ipfiremake openmailadmin
504 ipfiremake clamav
505 ipfiremake spamassassin
506 ipfiremake amavisd
507 ipfiremake alsa
508 ipfiremake mpg123
509 ipfiremake mpfire
510 ipfiremake guardian
511 ipfiremake libid3tag
512 ipfiremake libmad
513 ipfiremake libogg
514 ipfiremake libvorbis
515 ipfiremake libdvbpsi
516 ipfiremake lame
517 ipfiremake sox
518 ipfiremake libshout
519 ipfiremake icecast
520 ipfiremake icegenerator
521 ipfiremake mpd
522 ipfiremake mpc
523 ipfiremake xvid
524 ipfiremake libmpeg2
525 ipfiremake cmake
526 ipfiremake libpri
527 ipfiremake asterisk
528 ipfiremake gnump3d
529 ipfiremake libsigc++
530 ipfiremake applejuice
531 ipfiremake ocaml
532 ipfiremake mldonkey
533 ipfiremake libtorrent
534 ipfiremake rtorrent
535 ipfiremake ipfireseeder
536 ipfiremake rsync
537 ipfiremake tcpwrapper
538 ipfiremake portmap
539 ipfiremake nfs
540 ipfiremake nmap
541 ipfiremake ncftp
542 ipfiremake etherwake
543 ipfiremake bwm-ng
544 ipfiremake tripwire
545 ipfiremake sysstat
546 ipfiremake vsftpd
547 ipfiremake which
548 ipfiremake openswan
549 ipfiremake lsof
550 ipfiremake centerim
551 ipfiremake br2684ctl
552 ipfiremake pcmciautils
553 ipfiremake lm_sensors
554 ipfiremake collectd
555 ipfiremake lcd4linux
556 ipfiremake neon
557 ipfiremake subversion
558 ipfiremake tcptrack
559 ipfiremake teamspeak
560 ipfiremake elinks
561 ipfiremake igmpproxy
562 ipfiremake fbset
563 ipfiremake sdl
564 ipfiremake qemu
565 ipfiremake sane
566 ipfiremake netpbm
567 ipfiremake phpSANE
568 ipfiremake tunctl
569 ipfiremake nagios
570 ipfiremake ebtables
571 ipfiremake arptables
572 ipfiremake fontconfig
573 ipfiremake freefont
574 ipfiremake directfb
575 ipfiremake dfb++
576 ipfiremake ffmpeg
577 ipfiremake videolan
578 ipfiremake vdr
579 ipfiremake w_scan
580 ipfiremake git
581 ipfiremake squidclamav
582 ipfiremake bc
583 ipfiremake esniper
584 ipfiremake vnstat
585 ipfiremake vnstati
586 ipfiremake wpa_supplicant
587 ipfiremake hostapd
588 ipfiremake urlgrabber
589 ipfiremake syslinux
590 ipfiremake tftp-hpa
591 ipfiremake cpufrequtils
592 ipfiremake dbus
593 ipfiremake bluez
594 ipfiremake gutenprint
595 echo Build on $HOSTNAME > $BASEDIR/build/var/ipfire/firebuild
596 cat /proc/version >> $BASEDIR/build/var/ipfire/firebuild
597 echo >> $BASEDIR/build/var/ipfire/firebuild
598 git log -1 >> $BASEDIR/build/var/ipfire/firebuild
599 echo >> $BASEDIR/build/var/ipfire/firebuild
600 git status >> $BASEDIR/build/var/ipfire/firebuild
601 echo >> $BASEDIR/build/var/ipfire/firebuild
602 cat /proc/cpuinfo >> $BASEDIR/build/var/ipfire/firebuild
603 }
604
605 buildinstaller() {
606 # Run installer scripts one by one
607 LOGFILE="$BASEDIR/log/_build.installer.log"
608 export LOGFILE
609 ipfiremake as86
610 ipfiremake mbr
611 ipfiremake memtest
612 installmake linux-libc-header
613 installmake binutils
614 ipfiremake uClibc PASS=1
615 ipfiremake gcc INST=1
616 installmake uClibc PASS=2
617 installmake gcc INST=2
618 installmake uClibc PASS=3
619 installmake busybox
620 installmake udev
621 installmake slang
622 installmake newt
623 installmake gettext
624 installmake kbd
625 installmake popt
626 installmake sysvinit
627 installmake misc-progs
628 installmake libaal
629 installmake reiser4progs
630 installmake reiserfsprogs
631 installmake sysfsutils
632 installmake util-linux
633 installmake pciutils
634 installmake zlib
635 installmake mtd
636 installmake wget
637 installmake hwdata
638 installmake kudzu
639 installmake pcmciautils
640 installmake installer
641 installmake initrd
642 }
643
644 buildpackages() {
645 LOGFILE="$BASEDIR/log/_build.packages.log"
646 export LOGFILE
647 echo "... see detailed log in _build.*.log files" >> $LOGFILE
648
649 installmake strip
650
651 # Generating list of packages used
652 echo -n "Generating packages list from logs" | tee -a $LOGFILE
653 rm -f $BASEDIR/doc/packages-list
654 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
655 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
656 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
657 fi
658 done
659 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
660 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
661 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
662 rm -f $BASEDIR/doc/packages-list
663 # packages-list.txt is ready to be displayed for wiki page
664 beautify message DONE
665
666 # Update changelog
667 cd $BASEDIR
668 $0 git log
669
670 # Create images for install
671 ipfiremake cdrom ED=full
672
673 # Check if there is a loop device for building in virtual environments
674 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
675 ipfiremake usb-stick
676 fi
677
678 # Create updater package
679 ipfiremake updater
680 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
681
682 ipfirepackages
683
684 # Cleanup
685 stdumount
686 rm -rf $BASEDIR/build/tmp/*
687
688 # Generating total list of files
689 echo -n "Generating files list from logs" | tee -a $LOGFILE
690 rm -f $BASEDIR/log/FILES
691 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
692 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
693 echo "##" >>$BASEDIR/log/FILES
694 echo "## `basename $i`" >>$BASEDIR/log/FILES
695 echo "##" >>$BASEDIR/log/FILES
696 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
697 fi
698 done
699 beautify message DONE
700
701 cd $PWD
702 }
703
704 ipfirepackages() {
705 ipfiremake core-updates
706 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
707 if [ -e $BASEDIR/lfs/$i ]; then
708 ipfiredist $i
709 else
710 echo -n $i
711 beautify message SKIP
712 fi
713 done
714 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
715 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
716 rm -rf $BASEDIR/build/install/packages/*
717 }
718
719 # See what we're supposed to do
720 case "$1" in
721 build)
722 clear
723 BUILDMACHINE=`uname -m`
724 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
725 #only restore on a clean disk
726 if [ ! -f log/cleanup-toolchain-2-tools ]; then
727 if [ ! -n "$PACKAGE" ]; then
728 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
729 prepareenv
730 buildtoolchain
731 else
732 PACKAGENAME=${PACKAGE%.tar.gz}
733 beautify build_stage "Packaged toolchain compilation"
734 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
735 tar zxf $PACKAGE
736 prepareenv
737 else
738 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
739 fi
740 fi
741 else
742 echo -n "Using installed toolchain" | tee -a $LOGFILE
743 beautify message SKIP
744 prepareenv
745 fi
746
747 beautify build_start
748 beautify build_stage "Building LFS"
749 buildbase
750
751 beautify build_stage "Building IPFire"
752 buildipfire
753
754 beautify build_stage "Building installer"
755 buildinstaller
756
757 beautify build_stage "Building packages"
758 buildpackages
759 beautify build_end
760 ;;
761 shell)
762 # enter a shell inside LFS chroot
763 # may be used to changed kernel settings
764 prepareenv
765 entershell
766 ;;
767 clean)
768 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
769 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
770 $LOSETUP -d $i 2>/dev/null
771 done
772 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
773 umount $i
774 done
775 stdumount
776 for i in `seq 0 7`; do
777 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
778 umount /dev/loop${i} 2>/dev/null;
779 losetup -d /dev/loop${i} 2>/dev/null;
780 fi;
781 done
782 rm -rf $BASEDIR/build
783 rm -rf $BASEDIR/cdrom
784 rm -rf $BASEDIR/packages
785 rm -rf $BASEDIR/log
786 if [ -h /tools ]; then
787 rm -f /tools
788 fi
789 beautify message DONE
790 ;;
791 downloadsrc)
792 if [ ! -d $BASEDIR/cache ]; then
793 mkdir $BASEDIR/cache
794 fi
795 mkdir -p $BASEDIR/log
796 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
797 FINISHED=0
798 cd $BASEDIR/lfs
799 for c in `seq $MAX_RETRIES`; do
800 if (( FINISHED==1 )); then
801 break
802 fi
803 FINISHED=1
804 cd $BASEDIR/lfs
805 for i in *; do
806 if [ -f "$i" -a "$i" != "Config" ]; then
807 echo -ne "Loading $i"
808 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
809 if [ $? -ne 0 ]; then
810 beautify message FAIL
811 FINISHED=0
812 else
813 if [ $c -eq 1 ]; then
814 beautify message DONE
815 fi
816 fi
817 fi
818 done
819 done
820 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
821 ERROR=0
822 for i in *; do
823 if [ -f "$i" -a "$i" != "Config" ]; then
824 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
825 if [ $? -ne 0 ]; then
826 echo -ne "MD5 difference in lfs/$i"
827 beautify message FAIL
828 ERROR=1
829 fi
830 fi
831 done
832 if [ $ERROR -eq 0 ]; then
833 echo -ne "${BOLD}all files md5sum match${NORMAL}"
834 beautify message DONE
835 else
836 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
837 beautify message FAIL
838 fi
839 cd - >/dev/null 2>&1
840 ;;
841 toolchain)
842 clear
843 prepareenv
844 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
845 buildtoolchain
846 BUILDMACHINE=`uname -m`
847 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
848 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
849 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
850 build/{bin,etc,usr/bin,usr/local} \
851 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
852 log >> $LOGFILE
853 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
854 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
855 stdumount
856 ;;
857 gettoolchain)
858 BUILDMACHINE=`uname -m`
859 # arbitrary name to be updated in case of new toolchain package upload
860 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
861 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
862 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
863 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
864 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
865 cd $BASEDIR/cache/toolchains
866 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
867 if [ $? -ne 0 ]; then
868 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
869 else
870 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
871 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
872 else
873 exiterror "$PACKAGE.md5 did not match, check downloaded package"
874 fi
875 fi
876 else
877 echo "Toolchain is already downloaded. Exiting..."
878 fi
879 ;;
880 othersrc)
881 prepareenv
882 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
883 chroot $LFS /tools/bin/env -i HOME=/root \
884 TERM=$TERM PS1='\u:\w\$ ' \
885 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
886 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
887 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
888 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
889 if [ $? -eq "0" ]; then
890 beautify message DONE
891 else
892 beautify message FAIL
893 fi
894 stdumount
895 ;;
896 git)
897 case "$2" in
898 update|up)
899 git pull
900 ;;
901 commit|ci)
902 shift 2
903 git commit $*
904
905 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
906
907 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
908 read
909 [ -z $REPLY ] && exit 0
910 for i in y Y j J; do
911 if [ "$i" == "$REPLY" ]; then
912 $0 git push
913 exit $?
914 fi
915 done
916 exiterror "\"$REPLY\" is not a valid answer."
917 ;;
918 dist)
919 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
920 ;;
921 diff|di)
922 echo -ne "Make a local diff to last revision"
923 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
924 evaluate 1
925 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
926 git diff --stat
927 ;;
928 push)
929 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
930 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
931
932 git push ${GIT_URL} ${GIT_BRANCH}
933 ;;
934 log)
935 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
936 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
937
938 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
939 ;;
940 esac
941 ;;
942 uploadsrc)
943 PWD=`pwd`
944 cd $BASEDIR/cache/
945 echo -e "Uploading cache to ftp server:"
946 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
947 for i in *; do
948 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
949 grep -q $(basename $i) /tmp/ftplist
950 if [ "$?" -ne "0" ]; then
951 echo -ne "$(basename $i)"
952 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
953 if [ "$?" -ne "0" ]; then
954 beautify message FAIL
955 fi
956 fi
957 done
958 rm -f /tmp/ftplist
959 cd $PWD
960 exit 0
961 ;;
962 upload)
963 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
964 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
965 if [ -z $FTP_ISO_PORT ]; then
966 FTP_ISO_PORT=21
967 fi
968 cat <<EOF > .ftp-commands
969 mkdir -p $FTP_ISO_PATH$SVN_REVISION
970 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
971 quit
972 EOF
973 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
974 rm -f .ftp-commands
975
976 case "$2" in
977 iso)
978 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
979
980 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
981 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
982 if [ -e "$i" ]; then
983 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
984 if [ "$?" -eq "0" ]; then
985 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
986 else
987 echo "There was an error while uploading the file $i to the ftp server."
988 exit 1
989 fi
990 fi
991 done
992 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
993 if [ "$3" = "--with-sources-cd" ]; then
994 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
995 fi
996 ;;
997 paks)
998 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
999 if [ "$?" -eq "0" ]; then
1000 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1001 else
1002 echo -e "There was an error while uploading the packages to the ftp server."
1003 exit 1
1004 fi
1005 ;;
1006 esac
1007 ;;
1008 batch)
1009 if [ "$2" = "--background" ]; then
1010 batch_script
1011 exit $?
1012 fi
1013 if [ `screen -ls | grep -q ipfire` ]; then
1014 echo "Build is already running, sorry!"
1015 exit 1
1016 else
1017 if [ "$2" = "--rebuild" ]; then
1018 export IPFIRE_REBUILD=1
1019 echo "REBUILD!"
1020 else
1021 export IPFIRE_REBUILD=0
1022 fi
1023 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1024 screen -dmS ipfire $0 batch --background
1025 evaluate 1
1026 exit 0
1027 fi
1028 ;;
1029 watch)
1030 watch_screen
1031 ;;
1032 pxe)
1033 case "$2" in
1034 start)
1035 start_tftpd
1036 ;;
1037 stop)
1038 stop_tftpd
1039 ;;
1040 reload|restart)
1041 reload_tftpd
1042 ;;
1043 esac
1044 exit 0
1045 ;;
1046 lang)
1047 update_langs
1048 ;;
1049 "")
1050 clear
1051 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1052 do
1053 case $name in
1054 "IPFIRE: Downloadsrc")
1055 $0 downloadsrc
1056 ;;
1057 "IPFIRE: Build (silent)")
1058 $0 build-silent
1059 ;;
1060 "IPFIRE: Watch Build")
1061 $0 watch
1062 ;;
1063 "IPFIRE: Batch")
1064 $0 batch
1065 ;;
1066 "IPFIRE: Clean")
1067 $0 clean
1068 ;;
1069 "Help")
1070 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1071 cat doc/make.sh-usage
1072 ;;
1073 "LOG: Tail")
1074 tail -f log/_*
1075 ;;
1076 "Exit")
1077 break
1078 ;;
1079 esac
1080 done
1081 ;;
1082 config)
1083 make_config
1084 ;;
1085 *)
1086 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1087 cat doc/make.sh-usage
1088 ;;
1089 esac